//+------------------------------------------------------------------+
//|                                                     iAssorty.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Gray
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Tomato
#property indicator_color5 Aqua
#property indicator_color6 LightSeaGreen

#property indicator_maximum 400
#property indicator_minimum -400

#property indicator_style2 STYLE_DOT
#property indicator_style4 STYLE_DOT

//---- input parameters
extern int MACDScale=50000;
extern int MACDFastPeriod=12;
extern int MACDSlowPeriod=26;
extern int MACDSignalPeriod=9;
extern int MACDPrice=0;
extern int StScale=4;
extern int StKPeriod=5;
extern int StDPeriod=3;
extern int StSPeriod=3;
extern int StMethod=0;
extern int StPrice=0;
extern int StLevel=80;
extern int RSIScale=4;
extern int RSIPeriod=14;
extern int RSIPrice=0;
extern int RSILevel=70;
extern int CCIPeriod=14;
extern int CCIPrice=5;

SetIndexLabel(0,"MACD Histo");
SetIndexLabel(1,"MACD Signal");
SetIndexLabel(2,"Stoch Main");
SetIndexLabel(3,"Stoch Signal");
SetIndexLabel(4,"RSI");
SetIndexLabel(5,"CCI");

//---- buffers
double MacdM[];
double MacdS[];
double StM[];
double StS[];
double Rsi[];
double Cci[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){

   SetLevelValue(0,(StLevel-50)*StScale);
   SetLevelValue(1,((100-StLevel)-50)*StScale);   
   SetLevelValue(2,(RSILevel-50)*RSIScale);
   SetLevelValue(3,((100-RSILevel)-50)*RSIScale);     
   SetLevelValue(4,100);
   SetLevelValue(5,-100);
   
   

//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,MacdM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MacdS);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,StM);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,StS);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,Rsi);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,Cci);
   
   IndicatorDigits(1);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               MacdM[i]=iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,MACDSignalPeriod,MACDPrice,MODE_MAIN,i)*MACDScale;
               MacdS[i]=iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,MACDSignalPeriod,MACDPrice,MODE_SIGNAL,i)*MACDScale;
               StM[i]=(iStochastic(NULL,0,StKPeriod,StDPeriod,StSPeriod,StMethod,StPrice,MODE_MAIN,i)-50)*StScale;
               StS[i]=(iStochastic(NULL,0,StKPeriod,StDPeriod,StSPeriod,StMethod,StPrice,MODE_SIGNAL,i)-50)*StScale;
               Rsi[i]=(iRSI(NULL,0,RSIPeriod,RSIPrice,i)-50)*RSIScale;
               Cci[i]=iCCI(NULL,0,CCIPeriod,CCIPrice,i);
               
            }
   return(0);
  }
//+------------------------------------------------------------------+